# Load and View PDF Files in Vue

Learn how to load and view PDF files in a Vue3 application. Get started and see more from Document Solutions today.

## Content

This tutorial shows how to integrate the **Document Solutions for PDF Viewer (DsPdfViewer)** into a Vue 3 application. The DsPdfViewer lets users view and edit PDF files directly in the browser, including interactive PDF forms, and save modified documents on the client side. It supports all modern browsers and provides an efficient way to load and display PDF files in web applications.
If you want to follow along, feel free to [download the completed Vue 3 PDF Viewer sample project to explore the implementation](https://gccontent.blob.core.windows.net/gccontent/blogs/gcdocuments/20250514-Create-a-Vue-PDF-Viewer-app/pdf-viewer-app.zip "https://gccontent.blob.core.windows.net/gccontent/blogs/gcdocuments/20250514-Create-a-Vue-PDF-Viewer-app/pdf-viewer-app.zip"), or watch the video tutorial below:

<iframe width="610" height="343" src="https://www.youtube.com/embed/4Y7iZl5qm6Y" title="How to Create a Vue PDF Viewer Application" style="display: block; margin: 0 auto;"></iframe>

## Prerequisites

Before you begin, make sure the following tools are installed:

* Node.js (download the latest version from the official Node.js site)
* NPM (included with Node.js)
* Vue CLI (create new projects using the built-in Vue scaffolding tool)

Once these are installed, you can begin creating your Vue project.

***

## Create a Vue 3 Project

Use the following command to create a new Vue application:

```auto
npm create vue@latest
```

During setup, you’ll be prompted to choose optional features such as TypeScript or testing support.
After the project is created, navigate to the folder and install the Document Solutions PDF Viewer package. You can also install Bootstrap for optional styling:

```auto
cd pdf-viewer-app
npm install @mescius/dspdfviewer
npm install bootstrap
```

When installation is complete, the required files will be available in: node\_modules/@mescius/dspdfviewer/

***

## Add the PDF Viewer Component to the Vue Application

Open the App.vue file and replace the default template with a single host element for the viewer:

```auto
<template>
  <div id="viewer"></div>
</template>
```

Initialize the PDF Viewer inside the onMounted lifecycle hook.
Create a new instance of DsPdfViewer, set the worker source path, and call **[addDefaultPanels()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#adddefaultpanels "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#adddefaultpanels")** to display the toolbar and navigation panels.

```auto
<script setup>
import { onMounted } from 'vue'
import { DsPdfViewer } from '@mescius/dspdfviewer'
import 'bootstrap/dist/css/bootstrap.css'

onMounted(() => {
  const viewer = new DsPdfViewer(document.getElementById('viewer'), {
    workerSrc: "./node_modules/@mescius/dspdfviewer/dspdfviewer.worker.js"
  })
  viewer.addDefaultPanels()
})
</script>
```

Add CSS styles to ensure the viewer fills the page.
Edit main.css with the following rules:

```auto
html, body, #app {
  height: 100%;
  margin: 0;
  padding: 0;
}
#viewer {
  height: 100%;
  width: 100%;
}
```

Run the Vue 3 project, and you’ll see the PDF Viewer display in the browser window with its default interface panels.
![](https://cdn.mescius.io/document-site-files/images/b3d1b839-d589-484d-911e-bdee556db99b/emptyVuePDFviewer.746174.png)

***

## Load a Local PDF File in a Vue Application

With the viewer running, you can now load a PDF stored locally in your project.
For this example, place a file named social\_media\_schedule.pdf in public/pdfs/.
To display the file, use the **[open()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#open "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#open")** [method](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#open "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#open") of the viewer:

```auto
viewer.open("./public/pdfs/social_media_schedule.pdf");
```

When you run the app, the specified PDF file will load automatically in the DsPdfViewer.
![](https://cdn.mescius.io/document-site-files/images/b3d1b839-d589-484d-911e-bdee556db99b/VuefromFile.ff23e1.png)
You can also use the **[openLocalFile()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#openlocalfile "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#openlocalfile")**[ method](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#openlocalfile "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#openlocalfile") to let users select a file through a native open-file dialog.

***

## Load a PDF from a URL in a Vue Application

You can also open PDFs hosted on the same domain as your Vue app.
Use the same **[open()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open")**[ method](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open") and provide the relative URL to the PDF:

```auto
viewer.open("/document-solutions/javascript-pdf-viewer/demos/product-bundles/assets/pdf/helloworld.pdf");
```

The viewer will download and render the file directly in the browser.
![](https://cdn.mescius.io/document-site-files/images/b3d1b839-d589-484d-911e-bdee556db99b/vueFromUrl.270524.png)
This method works for any PDF that resides within your web application’s domain.

***

## Load a PDF from Another Domain (Using a CORS Proxy) in a Vue Application

When loading a PDF from a different domain, browsers may block the request due to CORS (Cross-Origin Resource Sharing) restrictions.
To handle this, DsPdfViewer supports a **SupportApi** configuration, which uses an ASP.NET Core service as a proxy for loading and streaming remote PDF files.

### Create a CORS Proxy Endpoint

In your ASP.NET Core project, add a controller named CorsProxyController:

```auto
[ApiController]
[Route("[controller]")]
public class CorsProxyController : ControllerBase
{
    private readonly IHttpClientFactory _httpClientFactory;
    public CorsProxyController(IHttpClientFactory httpClientFactory) => _httpClientFactory = httpClientFactory;

    [HttpGet]
    public async Task<IActionResult> Get(string url)
    {
        if (string.IsNullOrEmpty(url)) return BadRequest("Missing 'url' query parameter.");
        var client = _httpClientFactory.CreateClient();
        var response = await client.GetAsync(url);
        if (!response.IsSuccessStatusCode) return StatusCode((int)response.StatusCode);
        var stream = await response.Content.ReadAsStreamAsync();
        var contentType = response.Content.Headers.ContentType?.ToString() ?? "application/pdf";
        return File(stream, contentType);
    }
}
```

Register the HTTP client in Program.cs:

```auto
builder.Services.AddHttpClient();
```

### Update the Vue Component to Use the Proxy

Once the proxy service is running, configure the supportApi object in your Vue viewer setup:

```auto
onMounted(() => {
  const viewer = new DsPdfViewer("#viewer", {
    workerSrc: "https://cdn.mescius.com/ds-pdfviewer/latest/dspdfviewer.worker.js",
    restoreViewStateOnLoad: false,
    supportApi: {
      apiUrl: "https://localhost:7296",
      token: "support-api-demo-net-core-token-2021",
      webSocketUrl: false
    }
  });

  viewer.addDefaultPanels();
  viewer.open("https://localhost:7296/CorsProxy?url=https://www.africau.edu/images/default/sample.pdf");
});
```

After these steps, your Vue app can securely open and render PDFs from external domains without encountering CORS errors.
![](https://cdn.mescius.io/document-site-files/images/b3d1b839-d589-484d-911e-bdee556db99b/VuePDFcors.8a5fc0.png)

***

## FAQ

**Why doesn’t my PDF load when using a URL from another domain?**
This is typically caused by browser CORS restrictions. To fix this, configure the **[supportApi](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#supportapi)** option in DsPdfViewer to proxy remote file requests through your own server (for example, using an ASP.NET Core endpoint). This ensures cross-domain PDFs load securely without browser blocking.
**Can DsPdfViewer be used directly in a Vue 3 application without a backend?**
Yes. For local files or same-domain assets, no backend is required. You can use **[viewer.open()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open)** to load project PDFs or **[viewer.openLocalFile()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#openlocalfile)** to allow user-selected files. A backend is only needed when loading files from external URLs that lack CORS headers.
**Does DsPdfViewer support editing or only viewing PDFs in Vue?**
DsPdfViewer supports both viewing and editing features. Users can fill out interactive forms, modify annotations, add comments, and save updated PDFs all directly in the browser without requiring server round-trips. Editing features require a **Professional DsPdfViewer license** and is not included in the standard DsPdfViewer license provided with every DsPdf license.
**How can I customize the appearance of the PDF Viewer in Vue?**
You can use the built-in API methods like **[addDefaultPanels()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#adddefaultpanels)** or **[updatePanel()](https://developer.mescius.com/document-solutions/dot-net-pdf-api/docs/online/pdfviewer/customize-pdf-viewer-toolbar#toggle-visibility-of-sidebar-buttons)** to customize toolbars and navigation areas. Additionally, apply CSS styles or Bootstrap classes to adjust layout, colors, and overall viewer appearance.
**Can DsPdfViewer for Vue work with other frameworks or standalone HTML pages?**
Absolutely. DsPdfViewer is framework-agnostic, meaning it works seamlessly in Vue, React, Angular, or plain JavaScript/HTML environments. The API usage and configuration remain consistent across frameworks.

***

## Next Steps

* [Try the online demos to see features like form filling, annotation, and client-side saving in action](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/demos/ "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/demos/").
* [Learn more about upgrading to the Professional DsPdfViewer by watching the benefits webinar here.](https://developer.mescius.com/webinars/document-solutions-for-pdf-professional-viewer)
* [Watch the full video tutorial associated with this page here](https://developer.mescius.com/videos/document-solutions/how-to-create-a-vue-pdf-viewer-application).

# Load and View PDF Files in Angular

Learn how to load and view PDF files in an Angular application. Get started and see more from Document Solutions today.

## Content

This tutorial shows how to integrate the **Document Solutions for PDF Viewer (DsPdfViewer)** into an Angular application. The DsPdfViewer allows users to view and edit PDF content directly in the browser, including PDF forms, and save modified PDF files on the client side.
Feel free to [download the completed Angular PDF Viewer sample project to test locally](https://gccontent.blob.core.windows.net/gccontent/blogs/gcdocuments/20250502-load-and-view-pdf-angular-apps/pdf-viewer-app.zip "https://gccontent.blob.core.windows.net/gccontent/blogs/gcdocuments/20250502-load-and-view-pdf-angular-apps/pdf-viewer-app.zip") or follow along with the video tutorial below:

<iframe width="610" height="343" src="https://www.youtube.com/embed/fQoD33pLgNM" title="How to Create an Angular PDF Viewer Application" style="display: block; margin: 0 auto;"></iframe>

## Prerequisites

Before you begin, make sure you have the following installed:

* Node.js (download the latest version from the official Node.js website)
* Angular CLI (install globally using the following command):

```auto
npm install -g @angular/cli
```

Once your environment is ready, you can create and configure your Angular project.

***

## Create an Angular Project

Open a terminal and run the following commands to create a new Angular application named pdf-viewer-app:

```auto
ng new pdf-viewer-app
cd pdf-viewer-app
```

This will generate the basic Angular project structure with the expected files and folders.

***

## Install the Document Solutions PDF Viewer Package

To add the PDF Viewer to your project, install the @mescius/dspdfviewer package from npm:

```auto
npm install @mescius/dspdfviewer
```

After installation, the library files will be located in:
node\_modules/@mescius/dspdfviewer/

***

## Add the PDF Viewer Component to the Angular Application

Open the app.component.html file and add the following element to host the viewer:

```auto
<div id="viewer"></div>
```

Next, open app.component.ts and import the DsPdfViewer component:

```auto
import { Component, AfterViewInit } from "@angular/core";
import { DsPdfViewer } from "@mescius/dspdfviewer";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.less']
})
export class AppComponent implements AfterViewInit {
  title = 'pdf-viewer-app';

  ngAfterViewInit() {
    const viewer = new DsPdfViewer("#viewer", {
      workerSrc: "//node_modules/@mescius/dspdfviewer/dspdfviewer.worker.js",
      restoreViewStateOnLoad: false
    });

    viewer.addDefaultPanels();
  }
}
```

The **[workerSrc](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/ViewerOptions#workersrc "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/ViewerOptions#workersrc")**[ option](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/ViewerOptions#workersrc "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/ViewerOptions#workersrc") improves performance when rendering PDFs, and **[addDefaultPanels()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#adddefaultpanels "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#adddefaultpanels")** adds the standard toolbar and navigation panels to the viewer.

***

## Update the Angular Configuration

Open angular.json and adjust the following build settings to allow larger file sizes and CommonJS dependencies:

```auto
"budgets": [
  {
    "type": "initial",
    "maximumWarning": "8mb",
    "maximumError": "10mb"
  }
],
"build": {
  "builder": "@angular-devkit/build-angular:browser",
  "options": {
    "allowedCommonJsDependencies": [
      "@mescius/dspdfviewer"
    ]
  }
}
```

These updates ensure that the project can compile successfully with the DsPdfViewer package.

***

## Run the Application

Start the Angular application with the following command:

```auto
ng serve --open
```

Once the project builds, the DsPdfViewer will display as an empty viewer in the browser window.
![](https://cdn.mescius.io/document-site-files/images/b3d1b839-d589-484d-911e-bdee556db99b/blankpdfviewer.b34619.png)

***

## Load a Local PDF File in an Angular Application

To open a local PDF file, place it in your project folder at src/assets/pdf/newsletter.pdf.
Modify the app.component.ts file to load the PDF automatically when the app starts:

```auto
import { Component, AfterViewInit } from "@angular/core";
import { DsPdfViewer } from "@mescius/dspdfviewer";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.less']
})
export class AppComponent implements AfterViewInit {
  title = 'pdf-viewer-app';

  ngAfterViewInit() {
    const viewer = new DsPdfViewer("#viewer", {
      workerSrc: "//node_modules/@mescius/dspdfviewer/dspdfviewer.worker.js",
      restoreViewStateOnLoad: false
    });

    viewer.addDefaultPanels();
    viewer.open("assets/pdf/newsletter.pdf");
  }
}
```

After running the app, the specified PDF file will open in the viewer window.
![](https://cdn.mescius.io/document-site-files/images/b3d1b839-d589-484d-911e-bdee556db99b/loadedPDFviewer.f243b5.png)
The DsPdfViewer also includes an **[openLocalFile()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#openlocalfile "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#openlocalfile")**[ method](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#openlocalfile "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#openlocalfile") that allows users to choose and open a PDF using a file dialog.

***

## Load a PDF from a URL in an Angular Application

To open a PDF from a URL within the same domain, use the **[open()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open")**[ method](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/GcPdfViewer#open") and specify the path to the PDF:

```auto
viewer.open("/documents-api-pdf/docs/offlinehelp.pdf");
```

This method is useful when PDFs are stored on your server or within your web application’s resources.
![](https://cdn.mescius.io/document-site-files/images/b3d1b839-d589-484d-911e-bdee556db99b/urlPDF.daae38.png)

***

## Load a PDF from Another Domain (CORS) in an Angular Application

When trying to open a PDF from a remote domain, the browser may block it due to CORS restrictions. To handle this, DsPdfViewer supports proxy loading using the **SupportApi** server-side component.
The SupportApi is included with DsPdf and can be hosted in an ASP.NET Core WebAPI project. Once set up, you can reference it in your Angular client and use its CORS proxy feature.
Here’s an example implementation in app.component.ts:

```auto
import { Component, AfterViewInit } from "@angular/core";
import { DsPdfViewer } from "@mescius/dspdfviewer";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.less']
})
export class AppComponent implements AfterViewInit {
  title = 'pdf-viewer-app';

  ngAfterViewInit() {
    const viewer = new DsPdfViewer("#viewer", {
      workerSrc: "//node_modules/@mescius/dspdfviewer/dspdfviewer.worker.js",
      restoreViewStateOnLoad: false,
      supportApi: {
        apiUrl: "http://localhost:5004/api/pdf-viewer",
        token: "support-api-demo-net-core-token-2021",
        webSocketUrl: false
      }
    });

    viewer.addDefaultPanels();
    viewer.open("http://localhost:5004/api/pdf-viewer/CorsProxy?url=https://www.africau.edu/images/default/sample.pdf");
  }
}
```

When you run the application, the viewer will successfully load a remote PDF using the SupportApi proxy.
![](https://cdn.mescius.io/document-site-files/images/b3d1b839-d589-484d-911e-bdee556db99b/proxyPDF.f12b8a.png)

***

## FAQ

* **Why doesn’t my PDF load when using a URL from another domain?**
    Browsers block cross-origin requests without the proper CORS headers. When loading PDFs from external domains, use DsPdfViewer’s supportApi configuration. This proxies the file through your own server (SupportApi), avoiding CORS issues.
<br>
* **Does DsPdfViewer support PDF editing or only viewing?** 
    DsPdfViewer supports both viewing and editing depending on the PDF content. Users can fill interactive forms, edit annotations, add comments, and save updated PDF files on the client side.
<br>
* **Do I need a backend server to load PDFs?**
    Not always. The following scenarios outlined below provide more information:
* **Local files**: No backend required
* **Local project assets**: No backend required
* **Same-domain URLs**: No backend required
* **Cross-domain URLs**: Backend required (SupportApi proxy)
* **Can DsPdfViewer be used in frameworks other than Angular?**
    Yes. DsPdfViewer works with any JavaScript frameworks such as React, Vue, or plain HTML/JavaScript. The API usage is consistent across frameworks.

***

## Next Steps

* [Review the full Document Solutions PDF Viewer documentation for more examples](https://developer.mescius.com/document-solutions/dot-net-pdf-api/docs/online/pdfviewer "https://developer.mescius.com/document-solutions/dot-net-pdf-api/docs/online/pdfviewer").
* [Explore additional demos showing PDF form editing, annotations, and file-saving capabilities](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/demos/ "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/demos/").
* [Watch the full tutorial video on our website](https://developer.mescius.com/videos/document-solutions/how-to-create-an-angular-pdf-viewer-application).

# Load and View PDF Files in React

Learn how to load and view PDF files in a React application. Get started and see more from Document Solutions today.

## Content

This tutorial shows how to integrate the **Document Solutions for PDF Viewer (DsPdfViewer)** into a React application using Vite. The DsPdfViewer lets users view and edit PDF files directly in the browser, including interactive PDF forms, and save modified documents on the client side. It supports all modern browsers and provides an efficient way to load and display PDF files in web applications.

## Prerequisites

Before you begin, make sure the following tools are installed:

* Node.js (download the latest version from the official Node.js site)
* NPM (included with Node.js)
* A code editor, such as Visual Studio Code

Once these are installed, you can create and configure your React project.

***

## Create a React Project with Vite

Open a terminal and run the following command to create a new React application using Vite:

```auto
npm create vite@latest dspdfviewer-react -- --template react
```

During setup, you may be prompted to select a framework and variant. Select **React** as the framework and choose the variant that applies to your project. This tutorial uses JavaScript.
![Vite project set up for the React Framework](https://cdn.mescius.io/document-site-files/images/9cff3ae8-6cf4-4362-9202-5833da8e6dd7/ReactViewer1-20260529.b2b5c4.png)

After the project is created, navigate to the project folder and install the required dependencies:

```auto
cd dspdfviewer-react
npm install
```

You can confirm that the project runs successfully with the following command:

```auto
npm run dev
```

This starts the Vite development server and displays the default React application in the browser.

***

## Install the Document Solutions PDF Viewer Package

To add the PDF Viewer to your React project, install the **@mescius/dspdfviewer** package from npm:

```auto
npm install @mescius/dspdfviewer
```

You can also install Bootstrap for optional styling:

```auto
npm install bootstrap
```

After installation, the library files will be available in:
node\_modules/@mescius/dspdfviewer/
![React Vite Project Folder | NPM install for a React PDF Viewer | Document Solutions DsPdfViewer](https://cdn.mescius.io/document-site-files/images/9cff3ae8-6cf4-4362-9202-5833da8e6dd7/ReactViewer2-20260529.3548f3.png)
***

## Add the PDF Viewer Component to the React Application

Open the index.html file and make sure the page includes a root element where the React application will be mounted:

```auto
<!-- index.html -->
<!doctype html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <link rel="icon" type="image/svg+xml" href="/vite.svg" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>DsPdfViewer | Vite + React</title>
  </head>
  <body>
    <div id="root"></div>
    <script type="module" src="/src/main.jsx"></script>
  </body>
</html>
```

Next, open main.jsx and remove StrictMode from the default React template. This helps avoid compatibility issues such as double mounting or duplicate viewer initialization during development.

```auto
// main.jsx
import { createRoot } from 'react-dom/client'
import './index.css'
import App from './App.jsx'

createRoot(document.getElementById('root')).render(
  <App />
)
```

Update index.css so the application and viewer can fill the browser window:

```auto
/* index.css */
html,
body,
#root {
  height: 100%;
  margin: 0;
  padding: 0;
}

#viewer {
  width: 100%;
  height: calc(100vh - 10px);
}
```

Finally, replace the contents of App.jsx with the following code to initialize DsPdfViewer and add the default toolbar and sidebar panels:

```auto
// App.jsx
import { useEffect, useRef } from 'react';
import { DsPdfViewer } from '@mescius/dspdfviewer';
import 'bootstrap/dist/css/bootstrap.css';
import './App.css';

function App() {
  const viewerRef = useRef(null);

  useEffect(() => {
    if (!viewerRef.current) {
      console.error('Viewer container element not found');
      return;
    }

    let viewer = null;

    try {
      viewer = new DsPdfViewer(viewerRef.current, {
        workerSrc: './node_modules/@mescius/dspdfviewer/dspdfviewer.worker.js',
        restoreViewStateOnLoad: false
      });

      viewer.addDefaultPanels();
    } catch (error) {
      console.error('Failed to initialize DsPdfViewer:', error);
    }

    return () => {
      if (viewer) {
        viewer.dispose();
      }
    };
  }, []);

  return <div id="viewer" ref={viewerRef}></div>;
}

export default App;
```

The **[workerSrc](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/ViewerOptions#workersrc "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/ViewerOptions#workersrc")** option improves performance when rendering PDFs, and **[addDefaultPanels()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#adddefaultpanels "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#adddefaultpanels")** adds the standard toolbar and navigation panels to the viewer.

Run the React application with the following command:

```auto
npm run dev
```

Once the app builds, DsPdfViewer will display as an empty viewer in the browser window.
![A React App with an Empty PDF Viewer and Default Controls/Panels](https://cdn.mescius.io/document-site-files/images/9cff3ae8-6cf4-4362-9202-5833da8e6dd7/ReactViewer3-20260529.bcfe70.png)

***

## Load a Local PDF File in a React Application

With the viewer running, you can load a PDF stored locally in your project. For this example, place a file named social\_media\_schedule.pdf in the public/pdfs/ folder.

To display the file automatically when the app starts, call the **[open()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#open "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#open")** method after adding the default panels:

```auto
viewer.addDefaultPanels();
viewer.open('./pdfs/social_media_schedule.pdf');
```

The full App.jsx file should look like this:

```auto
// App.jsx
import { useEffect, useRef } from 'react';
import { DsPdfViewer } from '@mescius/dspdfviewer';
import 'bootstrap/dist/css/bootstrap.css';
import './App.css';

function App() {
  const viewerRef = useRef(null);

  useEffect(() => {
    if (!viewerRef.current) {
      console.error('Viewer container element not found');
      return;
    }

    let viewer = null;

    try {
      viewer = new DsPdfViewer(viewerRef.current, {
        workerSrc: './node_modules/@mescius/dspdfviewer/dspdfviewer.worker.js',
        restoreViewStateOnLoad: false
      });

      viewer.addDefaultPanels();
      viewer.open('./pdfs/social_media_schedule.pdf');
    } catch (error) {
      console.error('Failed to initialize DsPdfViewer:', error);
    }

    return () => {
      if (viewer) {
        viewer.dispose();
      }
    };
  }, []);

  return <div id="viewer" ref={viewerRef}></div>;
}

export default App;
```

When you run the application, the specified PDF file will load automatically in DsPdfViewer.
![React App | Loading a PDF into a JS Viewer/Editor Control | Developer Solution](https://cdn.mescius.io/document-site-files/images/9cff3ae8-6cf4-4362-9202-5833da8e6dd7/ReactViewer4-20260529.c50cce.png)
You can also use the **[openLocalFile()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#openlocalfile "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#openlocalfile")** method to let users select a PDF through a native open-file dialog.

***

## Load a PDF from a URL in a React Application

You can also open PDFs hosted on the same domain as your React application. Use the same **[open()](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#open "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#open")** method and provide the relative URL to the PDF:

```auto
viewer.open('/document-solutions/javascript-pdf-viewer/demos/product-bundles/assets/pdf/helloworld.pdf');
```

The viewer will download and render the file directly in the browser. This method works for any PDF that resides within your web application’s domain.
![Loading PDF from URL into React App using a JS PDF Viewer Control](https://cdn.mescius.io/document-site-files/images/9cff3ae8-6cf4-4362-9202-5833da8e6dd7/ReactViewer5-20260529.b1cdbc.png)

***

## Load a PDF from Another Domain (Using a CORS Proxy) in a React Application

When loading a PDF from a different domain, browsers may block the request due to CORS (Cross-Origin Resource Sharing) restrictions. To handle this, DsPdfViewer supports a **SupportApi** configuration, which uses an ASP.NET Core service as a proxy for loading and streaming remote PDF files.

### Create a CORS Proxy Endpoint

In your ASP.NET Core project, add a controller named CorsProxyController:

```auto
[ApiController]
[Route("[controller]")]
public class CorsProxyController : ControllerBase
{
    private readonly IHttpClientFactory _httpClientFactory;
    public CorsProxyController(IHttpClientFactory httpClientFactory) => _httpClientFactory = httpClientFactory;

    [HttpGet]
    public async Task<IActionResult> Get(string url)
    {
        if (string.IsNullOrEmpty(url)) return BadRequest("Missing 'url' query parameter.");
        var client = _httpClientFactory.CreateClient();
        var response = await client.GetAsync(url);
        if (!response.IsSuccessStatusCode) return StatusCode((int)response.StatusCode);
        var stream = await response.Content.ReadAsStreamAsync();
        var contentType = response.Content.Headers.ContentType?.ToString() ?? "application/pdf";
        return File(stream, contentType);
    }
}
```

Register the HTTP client, controllers, CORS policy, and DsPdfViewer services in Program.cs:

```auto
// Add CORS
builder.Services.AddCors(options =>
{
    options.AddPolicy("AllowAll", policy =>
    {
        policy.AllowAnyOrigin()
              .AllowAnyMethod()
              .AllowAnyHeader();
    });
});

// Register HTTP client and controllers
builder.Services.AddHttpClient();
builder.Services.AddControllers();
GcPdfViewerHub.ConfigureServices(builder.Services);

var app = builder.Build();

// Use CORS with the custom policy
app.UseCors("AllowAll");
app.MapControllers();
```

### Update the React Component to Use the Proxy

Once the proxy service is running, configure the supportApi object in your React viewer setup. Then call the **open()** method and pass in the proxy endpoint:

```auto
// App.jsx
import { useEffect, useRef } from 'react';
import { DsPdfViewer } from '@mescius/dspdfviewer';
import 'bootstrap/dist/css/bootstrap.css';
import './App.css';

function App() {
  const viewerRef = useRef(null);

  useEffect(() => {
    if (!viewerRef.current) {
      console.error('Viewer container element not found');
      return;
    }

    let viewer = null;

    try {
      viewer = new DsPdfViewer(viewerRef.current, {
        workerSrc: 'https://cdn.mescius.com/ds-pdfviewer/latest/dspdfviewer.worker.js',
        restoreViewStateOnLoad: false,
        supportApi: {
          apiUrl: 'https://localhost:7126',
          token: 'support-api-demo-net-core-token-2021',
          webSocketUrl: false
        }
      });

      viewer.addDefaultPanels();
      viewer.open('https://localhost:7126/CorsProxy?url=https://cdn.mescius.io/sites/developer/legal/eula/ds/20250401-DOCUMENTS-EULA.pdf');
    } catch (error) {
      console.error('Failed to initialize DsPdfViewer:', error);
    }

    return () => {
      if (viewer) {
        viewer.dispose();
      }
    };
  }, []);

  return <div id="viewer" ref={viewerRef}></div>;
}

export default App;
```

After these steps, your React app can securely open and render PDFs from external domains without encountering CORS errors.
![Load or Open a PDF from Another Domain URL into a React app using a CORS Proxy](https://cdn.mescius.io/document-site-files/images/9cff3ae8-6cf4-4362-9202-5833da8e6dd7/ReactViewer6-20260529.8f0ab3.png)

***

## FAQ

**Why doesn’t my PDF load when using a URL from another domain?**
This is typically caused by browser CORS restrictions. To fix this, configure the **[supportApi](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#supportapi "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/api/classes/DsPdfViewer#supportapi")** option in DsPdfViewer to proxy remote file requests through your own server, such as an ASP.NET Core endpoint.
<br>
**Can DsPdfViewer be used directly in a React application without a backend?**
Yes. For local files, project assets, and same-domain URLs, no backend is required. A backend is only needed when loading files from external URLs that do not include the required CORS headers.
<br>
**Does DsPdfViewer support editing or only viewing PDFs in React?**
DsPdfViewer supports both viewing and editing features. Users can fill interactive forms, modify annotations, add comments, and save updated PDFs directly in the browser. Editing features require a **Professional DsPdfViewer license** and are not included in the standard DsPdfViewer license provided with every DsPdf license.
<br>
**Why should StrictMode be removed from the React template?**
React StrictMode may mount components more than once during development, which can cause the PDF Viewer to initialize twice. Removing StrictMode from this sample helps avoid duplicate initialization behavior while setting up DsPdfViewer.
<br>
**Can DsPdfViewer work with frameworks other than React?**
Yes. DsPdfViewer is framework-agnostic and works in React, Vue, Angular, or plain JavaScript/HTML applications. The API usage and configuration remain consistent across frameworks.

***

## Next Steps

* [Try the online demos to see features like form filling, annotation, and client-side saving in action](https://developer.mescius.com/document-solutions/javascript-pdf-viewer/demos/ "https://developer.mescius.com/document-solutions/javascript-pdf-viewer/demos/").
* [Review the full Document Solutions PDF Viewer documentation for more examples](https://developer.mescius.com/document-solutions/dot-net-pdf-api/docs/online/pdfviewer "https://developer.mescius.com/document-solutions/dot-net-pdf-api/docs/online/pdfviewer").
* [Learn more about upgrading to the Professional DsPdfViewer](https://developer.mescius.com/webinars/document-solutions-for-pdf-professional-viewer "https://developer.mescius.com/webinars/document-solutions-for-pdf-professional-viewer").
